<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'pId',
    label: '主键',
    component: 'Input',
    hidden: true
  },{
    field: 'dataDate',
    label: '数据日期',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'createTime',
    label: '生成时间',
    component: 'DatePicker',
    componentProps: {
      type: 'daterange'
    },
  },
  {
    field: 'tId',
    label: '模板表id',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'tName',
    label: '报告名称',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'tCategory',
    label: '报告分类',
    component: 'Select',
    componentProps: {
      
    },
  },
  {
    field: 'organCode',
    label: '所属机构',
    component: 'Select',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

